#include <stdio.h>
#include <stdlib.h>

void save_(double *u, double *v, double *c, double *p, int *nx, int *ny, int *t, int *PPRANK)
{
  int i, j;
  double val;
  int valt;
  char s[256];
  FILE *fptr;
 
  sprintf(s, "%s.%d", "dump",*PPRANK);
  fptr = fopen(s, "wb");

  for (i = 0; i < *nx; i++)
    for (j = 0; j < *ny; j++) {
        val = u[i + (*nx)*j];
        fwrite(&val, sizeof(double), 1, fptr);
      }

  for (i = 0; i < *nx; i++)
    for (j = 0; j < *ny; j++) {
        val = v[i + (*nx)*j];
        fwrite(&val, sizeof(double), 1, fptr);
      }

  for (i = 0; i < *nx; i++)
    for (j = 0; j < *ny; j++) {
        val = c[i + (*nx)*j];
        fwrite(&val, sizeof(double), 1, fptr);
      }            

  for (i = 0; i < *nx; i++)
    for (j = 0; j < *ny; j++) {
        val = p[i + (*nx)*j];
        fwrite(&val, sizeof(double), 1, fptr);
      }

  valt = *t;
  fwrite(&valt, sizeof(int), 1, fptr);

  fclose(fptr);
}

void iniget_(double *u, double *v, 
			double *c, double *p, int *nx, 
			int *ny, int *t0, int *PPRANK)
{
  int i, j;
  double val;
  int valt;
  char s[256];
  FILE *fptr;

  sprintf(s, "%s.%d", "dump", *PPRANK);
  fptr = fopen(s, "rt");

  for (i = 0; i < *nx; i++)
    for (j = 0; j < *ny; j++) {
        fread(&val, sizeof(double), 1, fptr);
	u[i + (*nx)*j] = val;
      }

  for (i = 0; i < *nx; i++)
    for (j = 0; j < *ny; j++) {
        fread(&val, sizeof(double), 1, fptr);
	v[i + (*nx)*j] = val;
      }

  for (i = 0; i < *nx; i++)
    for (j = 0; j < *ny; j++) {
        fread(&val, sizeof(double), 1, fptr);
	c[i + (*nx)*j] = val;
      }            

  for (i = 0; i < *nx; i++)
    for (j = 0; j < *ny; j++) {
        fread(&val, sizeof(double), 1, fptr);
	p[i + (*nx)*j] = val;
      }

  fread(&valt, sizeof(int), 1, fptr);
  *t0 = valt;
  
  fclose(fptr);
}
